#pragma once

#include <windows.h>
#include <tchar.h>
#include <vector>

namespace tipbase
{
	struct WindowVersion
	{
		enum Type{
			win_7_higher = 71,
			win_7	=  70,
			win_VISTA = 60,
			win_2003 = 52,
			win_XP = 51,
			win_2000 = 50,
			win_NT = 40,
			win_ME_9x = 0,
		};
	};

	class CheckInExecution
	{
	public:
		static WindowVersion::Type	GetWindowVersion();
		static BOOL					CheckMutex(const TCHAR *key);
		static BOOL					CheckMutex(const TCHAR *key, HANDLE& handle);
		static BOOL					CheckNetworkStatus(const TCHAR *address, int port, int timeout);
		static BOOL					CheckInstallRight();
	};

	const int RETRY_NETWORK_CONNECT_COUNT = 30;
	const int RETRY_NETWORK_CONNECT_SLEEP_TIME = 10000;
}